package com.jeeplus.test.rank.service;

import cn.hutool.core.collection.CollectionUtil;
import cn.hutool.core.util.ObjectUtil;
import cn.hutool.core.util.StrUtil;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.jeeplus.sys.utils.UserUtils;
import com.jeeplus.test.rank.domain.*;
import com.jeeplus.test.rank.mapper.RankLevelMapper;
import com.jeeplus.test.rank.mapper.RankMapper;
import com.jeeplus.test.rank.mapper.RankRRsMapper;
import com.jeeplus.test.rank.service.dto.RankDTO;
import com.jeeplus.test.rank.service.dto.RankSequenceDTO;
import com.jeeplus.test.rank.service.mapstruct.RankSequenceWrapper;
import com.jeeplus.test.rank.service.mapstruct.RankWrapper;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.util.ArrayList;
import java.util.List;

@Service
@Transactional
public class RankService extends ServiceImpl<RankMapper, Rank> {

    @Autowired
    private RankMapper rankMapper;

    @Autowired
    private RankRRsMapper rankRRsMapper;

    public IPage<RankDTO> findList(Page<RankDTO> page, QueryWrapper<Rank> queryWrapper){
        queryWrapper.eq("r.del_flag","0");
        return rankMapper.findList(page,queryWrapper);
    }

    public RankDTO queryById(String id){
        return rankMapper.getById(id);
    }

    public void saveRank(RankDTO rankDTO){
        Rank rank = RankWrapper.INSTANCE.toEntity(rankDTO);
        this.saveOrUpdate(rank);
        if(ObjectUtil.isNotEmpty(rankDTO)){
            if(StrUtil.isNotEmpty(rankDTO.getId())){
                rankRRsMapper.delete(new QueryWrapper<RankRRs>().eq("rank_id",rankDTO.getId()));
                if(CollectionUtil.isNotEmpty(rankDTO.getSequenceIdList())){
                    rankRRsMapper.insertListById(rankDTO.getId(),rankDTO, UserUtils.getCurrentUserDTO().getId());
                }
            }{
                rankRRsMapper.insertListById(rank.getId(),rankDTO, UserUtils.getCurrentUserDTO().getId());
            }
        }
    }

    public void updateUseFlagById(List<String> ids, String useFlag){
        rankMapper.updateUseFlagById(ids,useFlag);
    }
}